<template>
    <div class="team">
        <q-page class="row background-content">
            <div class="col-12">
                <div class="row q-px-xl q-px-lg- q-px-xs-md">
                    <div class="col-12">
                        <div
                            class="page-content no-scroll items-center q-pb-lg"
                        >
                            <div
                                class="team-home"
                                v-if="state.currentPage == 'team-home'"
                            >
                                <div class="row q-mt-lg">
                                    <div class="col-md-4 col-12 q-mb-md">
                                        <q-input
                                            outlined
                                            bottom-slots
                                            v-model="search"
                                            :label="$t('team.search')"
                                            :loading="state.loadingState"
                                            debounce="500"
                                            bg-color="transparent"
                                            clearable
                                            dense
                                            class="border-radius-10"
                                        >
                                            <template v-slot:prepend>
                                                <q-icon
                                                    name="search"
                                                    class="text-5B9ADD"
                                                />
                                            </template>
                                        </q-input>
                                    </div>
                                </div>

                                <!-- MEMBER LIST -->
                                <div class="row">
                                    <div
                                        class="
                                            col-md-4 col-lg-3 col-12
                                            q-pr-md-md q-pb-md
                                        "
                                        v-for="(
                                            member, index
                                        ) in state.memberList"
                                        :key="'member-' + index"
                                    >
                                        <q-item
                                            dark
                                            bordered
                                            class="
                                                bg-member
                                                my-card
                                                border-radius-15
                                            "
                                        >
                                            <div class="option-container">
                                                <q-btn
                                                    color="white"
                                                    size="lg"
                                                    round
                                                    flat
                                                    icon="more_horiz"
                                                    v-if="
                                                        permissions.member
                                                            ?.delete
                                                    "
                                                >
                                                    <q-menu
                                                        fit
                                                        anchor="bottom right"
                                                        self="center middle"
                                                        auto-close
                                                        class="border-radius-20"
                                                    >
                                                        <q-list
                                                            class="
                                                                label-buttons-container
                                                            "
                                                        >
                                                            <q-item
                                                                clickable
                                                                @click="
                                                                    viewBranch(
                                                                        member,
                                                                        'add'
                                                                    )
                                                                "
                                                            >
                                                                <q-item-section
                                                                    class="
                                                                        label-buttons
                                                                    "
                                                                    avatar
                                                                >
                                                                    <q-icon
                                                                        color="primary"
                                                                        name="img:icons\leaf.png"
                                                                    />
                                                                </q-item-section>
                                                                <q-item-section
                                                                    class="
                                                                        text-primary
                                                                        font-16
                                                                    "
                                                                >
                                                                    Assign to
                                                                    branch
                                                                </q-item-section>
                                                            </q-item>
                                                            <q-item
                                                                clickable
                                                                @click="
                                                                    removeMember(
                                                                        member.id
                                                                    )
                                                                "
                                                            >
                                                                <q-item-section
                                                                    class="
                                                                        label-buttons
                                                                    "
                                                                    avatar
                                                                >
                                                                    <q-icon
                                                                        color="red"
                                                                        name="remove_circle"
                                                                    />
                                                                </q-item-section>
                                                                <q-item-section
                                                                    class="
                                                                        text-FA6767
                                                                        font-16
                                                                    "
                                                                >
                                                                    {{
                                                                        $t(
                                                                            'button.remove'
                                                                        )
                                                                    }}
                                                                </q-item-section>
                                                            </q-item>
                                                        </q-list>
                                                    </q-menu>
                                                </q-btn>
                                            </div>

                                            <q-item-section
                                                avatar
                                                class="q-py-md"
                                                @click="
                                                    selectCurrentPage(
                                                        'team-profile',
                                                        member
                                                    )
                                                "
                                            >
                                                <!-- <q-img
                                                    class="
                                                        border-radius-50
                                                        pointer
                                                    "
                                                    :src="
                                                        member.user.imageUrl
                                                            ? member.user
                                                                  .imageUrl
                                                            : '/images/default.png'
                                                    "
                                                    width="100px"
                                                    height="100px"
                                                /> -->
                                                <div
                                                    class="
                                                        members-pic-container
                                                    "
                                                >
                                                    <q-img
                                                        class="
                                                            border-radius-50
                                                            pointer
                                                        "
                                                        :src="
                                                            member.user.imageUrl
                                                                ? member.user
                                                                      .imageUrl
                                                                : '/images/default.png'
                                                        "
                                                        width="82px"
                                                        height="82px"
                                                    />
                                                    <div
                                                        class="rounded-status"
                                                    ></div>
                                                </div>
                                            </q-item-section>
                                            <q-item-section
                                                class="members-detail-container"
                                            >
                                                <div
                                                    class="
                                                        members-name
                                                        font-16
                                                        helvetica-neue-medium
                                                        pointer
                                                    "
                                                    @click="
                                                        selectCurrentPage(
                                                            'team-profile',
                                                            member
                                                        )
                                                    "
                                                >
                                                    {{ member.user.name }}
                                                </div>
                                                <div class="q-select">
                                                    <q-select
                                                        @update:model-value="
                                                            changeRole(
                                                                $event,
                                                                member.id
                                                            )
                                                        "
                                                        :dense="dense"
                                                        outlined
                                                        v-model="member.role"
                                                        :options="roleList"
                                                        option-value="id"
                                                        option-label="name"
                                                        v-if="
                                                            permissions.member
                                                                ?.update
                                                        "
                                                    />
                                                </div>
                                                <div class="q-mt-xs">
                                                    <q-btn
                                                        no-caps
                                                        text-color="black"
                                                        class="
                                                            full-width
                                                            branch-button
                                                            font-12
                                                            helvetica-neue-medium
                                                        "
                                                        @click="
                                                            viewBranch(
                                                                member,
                                                                'view'
                                                            )
                                                        "
                                                        :label="
                                                            $t(
                                                                'button.viewBranch'
                                                            )
                                                        "
                                                    />
                                                </div>
                                            </q-item-section>
                                            <q-item-section
                                                avatar
                                                top
                                                v-if="
                                                    permissions.member?.delete
                                                "
                                            >
                                                <!-- <q-btn
                                                    color="white"
                                                    size="xl"
                                                    round
                                                    flat
                                                    icon="more_horiz"
                                                    v-if="
                                                        permissions.member
                                                            ?.delete
                                                    "
                                                >
                                                    <q-menu
                                                        fit
                                                        anchor="bottom right"
                                                        self="top start"
                                                        auto-close
                                                        class="border-radius-20"
                                                    >
                                                        <q-list>
                                                            <q-item
                                                                clickable
                                                                @click="
                                                                    removeMember(
                                                                        member.id
                                                                    )
                                                                "
                                                            >
                                                                <q-item-section
                                                                    avatar
                                                                >
                                                                    <q-icon
                                                                        color="red"
                                                                        name="remove_circle"
                                                                    />
                                                                </q-item-section>
                                                                <q-item-section>
                                                                    {{
                                                                        $t(
                                                                            'button.remove'
                                                                        )
                                                                    }}
                                                                </q-item-section>
                                                            </q-item>
                                                        </q-list>
                                                    </q-menu>
                                                </q-btn> -->
                                            </q-item-section>
                                        </q-item>
                                    </div>
                                </div>
                            </div>

                            <!-- profile page -->
                            <div
                                class="team-container team-profile"
                                v-if="state.currentPage == 'team-profile'"
                            >
                                <div class="row col-12">
                                    <div
                                        class="
                                            offset-md-2
                                            col-md-1
                                            text-right
                                            font-18
                                            text-black
                                            q-pt-lg q-mt-md-lg
                                        "
                                    >
                                        <q-btn
                                            flat
                                            no-caps
                                            @click="
                                                selectCurrentPage('team-home')
                                            "
                                        >
                                            <q-icon
                                                name="arrow_back"
                                                color="black"
                                                size="25px"
                                            />
                                            <span
                                                class="
                                                    font-18
                                                    helvetica-neue-medium
                                                    q-pl-md
                                                "
                                            >
                                                {{ $t('button.back') }}
                                            </span>
                                        </q-btn>
                                    </div>
                                    <div
                                        class="
                                            col-12 col-md-6
                                            q-pl-xs
                                            font-18
                                            text-black
                                            q-mt-md
                                        "
                                    >
                                        <member-history
                                            :member="state.selectedMemberInfo"
                                        />
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <branch-selection
                v-if="state.selectionBranch"
                v-model="state.selectionBranch"
                :type="state.types"
                :memberInfo="state.memberBranchInfo"
                @update-branch="updateBranch"
            />
        </q-page>
    </div>
</template>
<script lang="ts">
/* eslint-disable @typescript-eslint/no-unsafe-call */
/* eslint-disable @typescript-eslint/no-unsafe-member-access */
/* eslint-disable @typescript-eslint/no-unsafe-assignment */
import { useStore } from 'src/store';
import {
    defineComponent,
    ref,
    reactive,
    computed,
    watch,
    onMounted
} from 'vue';
import { MemberListResponseResult } from 'src/services/responses/member/MemberListResponse';
import MemberHistory from 'src/components/team/MemberHistory.vue';
import { mapGetters } from 'vuex';
import BranchSelection from '../modals/BranchSelection.vue';

export default defineComponent({
    name: 'MemberList',
    components: { MemberHistory, BranchSelection },
    computed: {
        ...mapGetters({
            getRoles: 'role/getRole',
            permissions: 'role/getPermissions'
        })
    },
    setup() {
        // store
        const store = useStore();

        const selectedBusinessId = computed(() => {
            return store.state.business.businessID;
        });
        // data
        let search = ref('');
        let pendingSearch = ref('');

        let state = reactive({
            loadingState: ref(false),
            selectionBranch: ref(false),
            searchList: [] as any,
            pendingList: [] as any,
            memberList: [] as any,
            roles: [] as any,
            currentPage: 'team-home',
            selectedMember: '',
            memberBranchInfo: {} as any,
            types: '' as string,
            selectedMemberInfo: {} as any
        });

        // computed
        const memberListRemoved = computed(() => {
            return store.state.member.removed;
        });

        const roleList = computed(() => {
            return store.state.role.role;
        });

        // watch
        watch(search, async (currentValue) => {
            if (currentValue) {
                await searchFunction(currentValue);
            } else {
                state.loadingState = false;
                getMembers();
            }
        });

        watch(memberListRemoved, () => {
            store.commit('member/setRemoved', false);
            updateMemberList(store.state.member.allList, 1);
        });

        watch(selectedBusinessId, () => {
            getMembers();
        });

        store.watch(
            (state) => state.member.list,
            () => {
                getMembers();
            }
        );

        // methods
        const searchFunction = async (search: string) => {
            if (store.state.role.permissions.member?.list) {
                state.loadingState = true;
                const result: MemberListResponseResult = await store.dispatch(
                    'member/searchMembers',
                    {
                        page: 1,
                        limit: 10,
                        keyword: search,
                        branchIds: [store.state.branch.branch.id]
                    }
                );

                if (result.members.length > 0) {
                    state.loadingState = false;
                    state.memberList = result.members;
                } else {
                    state.loadingState = false;
                }
            }
        };

        const getMembers = async () => {
            await store.dispatch('member/getList', {
                status: 1,
                type: 'all'
            });

            const result = store.state.member.allList;
            if (result) {
                state.memberList = result;
            }
        };

        const viewBranch = (member: any, type: any) => {
            /* state.types = type
           state.memberBranchInfo = member */
            state.types = type;
            state.memberBranchInfo = member;
            setTimeout(() => {
                state.selectionBranch = true;
            }, 200);
        };

        const removeMember = async (id: string) => {
            if (store.state.role.permissions.member?.delete) {
                await store.dispatch('member/delete', {
                    memberId: id
                });
            }
        };
        const updateBranch = () => {
            state.selectionBranch = false;
            getMembers();
        };

        const updateMemberList = (result: any, status: number) => {
            if (status == 1) {
                state.memberList = result;
            } else {
                state.pendingList = result;
            }
        };

        const changeRole = async (role: any, memberId: string) => {
            if (store.state.role.permissions.member?.update) {
                await store.dispatch('member/update', {
                    memberId,
                    roleId: role.id
                });
            }
        };

        const selectCurrentPage = (page: string, member?: any) => {
            if (store.state.role.permissions.member?.auditLog) {
                state.currentPage = page;
                state.selectedMember = member?.id ?? '';
                state.selectedMemberInfo = member ?? '';
            }
        };

        onMounted(getMembers);

        return {
            state,
            search,
            pendingSearch,
            tab: ref('member'),
            dense: ref(true),
            getMembers,
            removeMember,
            roleList,
            changeRole,
            selectCurrentPage,
            selectedBusinessId,
            viewBranch,
            updateBranch
        };
    }
});
</script>
